Browse Source

hwsim: scripts to test against virtual network

Mathy Vanhoef 7 years ago
parent
commit
af84e1247d

+ 11 - 0
hwsim-test-network/gen-traffic.py

@@ -0,0 +1,11 @@
+#!/usr/bin/env python2
+import logging, time
+logging.getLogger("scapy.runtime").setLevel(logging.ERROR)
+from scapy.all import *
+
+p = Ether(dst="02:00:00:00:02:00")/ARP(op=2, pdst="192.168.100.12", hwdst="02:00:00:00:02:00")
+
+while True:
+	sendp(p, iface="wlan0")
+	sendp(p, iface="wlan1")
+	time.sleep(1)

+ 36 - 0
hwsim-test-network/hostap0.conf

@@ -0,0 +1,36 @@
+interface=wlan0
+ctrl_interface=/var/run/hostapd
+
+bridge=br0
+driver=nl80211
+
+ssid=simulnet
+hw_mode=g
+channel=1
+
+wpa=3
+wpa_key_mgmt=WPA-PSK FT-PSK
+wpa_pairwise=CCMP
+wpa_passphrase=password
+wpa_group_rekey=3600
+
+nas_identifier=nas0.example.com
+mobility_domain=a1b2
+r0_key_lifetime=10000
+reassociation_deadline=1000
+pmk_r1_push=1
+
+# Normally this is set to the own MAC address of the interface
+r1_key_holder=000102030405
+# Here we give information when receiving a network request from another hostapd instance.
+# - r0kh: we are r1kh and other hostapd is acting as r0kh (we are pulling key)
+# - r1kh: we are r0kh and communicate with a r1kh (we are pushing key or sending reply to pull)
+r0kh=02:00:00:00:01:00 nas1.example.com 0f0e0d0c0b0a09080706050403020100
+r1kh=02:00:00:00:01:00 00:01:02:03:04:06 000102030405060708090a0b0c0d0e0f
+
+
+# BSS Transition Management - used to force an FT roam
+bss_transition=1
+
+# So we only have to target authentication frames
+ft_over_ds=0

+ 2 - 0
hwsim-test-network/hostap0.sh

@@ -0,0 +1,2 @@
+#!/bin/bash
+hostapd hostap0.conf $@

+ 35 - 0
hwsim-test-network/hostap1.conf

@@ -0,0 +1,35 @@
+interface=wlan1
+ctrl_interface=/var/run/hostapd
+
+bridge=br1
+driver=nl80211
+
+ssid=simulnet
+hw_mode=g
+channel=1
+
+wpa=3
+wpa_key_mgmt=WPA-PSK FT-PSK
+wpa_pairwise=CCMP
+wpa_passphrase=password
+wpa_group_rekey=3600
+
+nas_identifier=nas1.example.com
+mobility_domain=a1b2
+r0_key_lifetime=10000
+reassociation_deadline=1000
+pmk_r1_push=1
+
+# Normally this is set to the own MAC address of the interface
+r1_key_holder=000102030406
+# Here we give information when receiving a network request from another hostapd instance.
+# - r0kh: we are r1kh and other hostapd is acting as r0kh (we are pulling key)
+# - r1kh: we are r0kh and communicate with a r1kh (we are pushing key or sending reply to pull)
+r0kh=02:00:00:00:00:00 nas0.example.com 000102030405060708090a0b0c0d0e0f
+r1kh=02:00:00:00:00:00 00:01:02:03:04:05 0f0e0d0c0b0a09080706050403020100
+
+# BSS Transition Management - used to force an FT roam
+bss_transition=1
+
+# So we only have to target authentication frames
+ft_over_ds=0

+ 2 - 0
hwsim-test-network/hostap1.sh

@@ -0,0 +1,2 @@
+#!/bin/bash
+hostapd hostap1.conf $@

+ 37 - 0
hwsim-test-network/initradios.sh

@@ -0,0 +1,37 @@
+#!/bin/bash
+set -e
+
+function bridgeup {
+	ifconfig $1 down 2> /dev/null || true
+	brctl delbr $1 2> /dev/null || true
+	brctl addbr $1
+	brctl setfd $1 0
+	brctl addif $1 $2
+	ifconfig $1 $3
+	ifconfig $1 up
+}
+
+# Configure the virtual or real interfaces
+rfkill unblock wifi 2> /dev/null || true
+rmmod mac80211_hwsim 2> /dev/null || true
+modprobe mac80211_hwsim radios=3
+
+macchanger -m 02:00:00:00:00:00 wlan0 > /dev/null || true
+macchanger -m 02:00:00:00:01:00 wlan1 > /dev/null || true
+macchanger -m 02:00:00:00:02:00 wlan2 > /dev/null || true
+
+vtund -s -f vtund.server.conf
+vtund -f vtund.client.conf conn1 127.0.0.1
+sleep 0.4
+ifconfig tap0 up
+ifconfig tap1 up
+
+bridgeup br0 tap0 192.168.168.101
+bridgeup br1 tap1 192.168.168.102
+
+ifconfig wlan0 192.168.100.10
+ifconfig wlan1 192.168.100.11
+ifconfig wlan2 192.168.100.12
+
+echo "Done. It's recommended to execute this script twice. Remember to disable Wi-Fi in the OS."
+

+ 12 - 0
hwsim-test-network/supplicant.conf

@@ -0,0 +1,12 @@
+ctrl_interface=/var/run/wpa_supplicant
+
+network={
+	# Network config
+	ssid="simulnet"
+	scan_ssid=1
+	key_mgmt=FT-PSK
+
+	psk="password"
+	#psk="WRONG PASSWORD"
+}
+

+ 2 - 0
hwsim-test-network/supplicant.sh

@@ -0,0 +1,2 @@
+#!/bin/bash
+wpa_supplicant -D nl80211 -i wlan2 -c supplicant.conf $@

+ 4 - 0
hwsim-test-network/vtund.client.conf

@@ -0,0 +1,4 @@
+conn1 {
+  passwd XXXX;
+  device tap1;
+}

+ 11 - 0
hwsim-test-network/vtund.server.conf

@@ -0,0 +1,11 @@
+default {
+  type ether;
+  proto udp;
+  keepalive yes;
+  encrypt no;
+}
+
+conn1 {
+  passwd XXXX;
+  device tap0;
+}